package Mail::POP3Client;
use strict;
use warnings;
use Carp;
use IO::Socket qw(SOCK_STREAM);
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);
require Exporter;
@ISA=qw(Exporter);
@EXPORT=qw(
);
my$ID=q( $Id: POP3Client.pm,v 2.18 2008/02/27 03:03:21 ssd Exp $ );
$VERSION=substr q$Revision: 2.18 $,10;
sub new{my$classname=shift;
my$self={DEBUG=>0,SERVER=>"pop3",PORT=>110,COUNT=>-1,SIZE=>-1,ADDR=>"",STATE=>'DEAD',MESG=>'OK',BANNER=>'',MESG_ID=>'',AUTH_MODE=>'BEST',EOL=>"\015\012",TIMEOUT=>60,STRIPCR=>0,LOCALADDR=>undef,SOCKET=>undef,USESSL=>0,};
$self->{tranlog}=();
$^O=~/MacOS/i&&($self->{STRIPCR}=1);
bless($self,$classname);
$self->_init(@_);
if(defined($self->User())&&defined($self->Pass())){$self->Connect();}return$self;}sub _init{my$self=shift;
if(@_&&(scalar(@_)%2==0)){my%hashargs=@_;
if((defined($hashargs{USER})&&defined($hashargs{PASSWORD}))||defined($hashargs{HOST})){foreach my $key(keys%hashargs){$self->{$key}=$hashargs{$key};}}else{$self->_initOldStyle(@_);}}else{$self->_initOldStyle(@_);}}sub _initOldStyle{my$self=shift;
$self->User(shift);
$self->Pass(shift);
my$host=shift;
$host&&$self->Host($host);
my$port=shift;
$port&&$self->Port($port);
my$debug=shift;
$debug&&$self->Debug($debug);
my$auth_mode=shift;
$auth_mode&&($self->{AUTH_MODE}=$auth_mode);
my$localaddr=shift;
$localaddr&&($self->{LOCALADDR}=$localaddr);}sub Version{return$VERSION;}sub Alive{my$me=shift;
$me->State=~/^AUTHORIZATION$|^TRANSACTION$/i;}sub State{my$me=shift;
my$stat=shift or return$me->{STATE};
$me->{STATE}=$stat;}sub Message{my$me=shift;
my$msg=shift or return$me->{MESG};
$me->{MESG}=$msg;}sub Debug{my$me=shift;
my$debug=shift or return$me->{DEBUG};
$me->{DEBUG}=$debug;}sub Port{my$me=shift;
my$port=shift or return$me->{PORT};
$me->{PORT}=$port;}sub Host{my$me=shift;
my$host=shift or return$me->{HOST};
$me->{HOST}=$host;}sub LocalAddr{my$me=shift;
my$addr=shift or return$me->{LOCALADDR};
$me->{LOCALADDR}=$addr;}sub Socket{my$me=shift;
my$socket=shift or return$me->{'SOCKET'};
$me->{'SOCKET'}=$socket;}sub AuthMode{my$me=shift;
my$mode=shift;
return$me->{'AUTH_MODE'}unless$mode;
$me->{'AUTH_MODE'}=$mode;}sub User{my$me=shift;
my$user=shift or return$me->{USER};
$me->{USER}=$user;}sub Pass{my$me=shift;
my$pass=shift or return$me->{PASSWORD};
$me->{PASSWORD}=$pass;}sub Password{Pass(@_);}sub Count{my$me=shift;
my$c=shift;
if(defined$c and length($c)>0){$me->{COUNT}=$c;}else{return$me->{COUNT};}}sub Size{my$me=shift;
my$c=shift;
if(defined$c and length($c)>0){$me->{SIZE}=$c;}else{return$me->{SIZE};}}sub EOL{my$me=shift;
return$me->{'EOL'};}sub Close{my$me=shift;
if($me->Alive()&&$me->Socket()&&$me->Socket()->connected()){$me->_sockprint("QUIT",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for QUIT");
undef$me->{SOCKET};
return 0;}$me->Message($line);
close($me->Socket())or$me->Message("close failed: $!")and do{undef$me->{SOCKET};
return 0;};
$me->State('DEAD');
undef$me->{SOCKET};
$line=~/^\+OK/i||return 0;}1;}sub close{Close(@_);}sub logout{Close(@_);}sub DESTROY{my$me=shift;
$me->Close;}sub Connect{my($me,$host,$port)=@_;
$host and$me->Host($host);
$port and$me->Port($port);
$me->Close();
my$s=$me->{SOCKET};
$s||do{if($me->{USESSL}){if($me->Port()==110){$me->Port(995);}eval{require IO::Socket::SSL;};
$@and$me->Message("Could not load IO::Socket::SSL: $@")and return 0;
$s=IO::Socket::SSL->new(PeerAddr=>$me->Host(),PeerPort=>$me->Port(),Proto=>"tcp",Type=>SOCK_STREAM,LocalAddr=>$me->LocalAddr(),Timeout=>$me->{TIMEOUT})or$me->Message("could not connect SSL socket [$me->{HOST}, $me->{PORT}]: $!")and return 0;
$me->{SOCKET}=$s;}else{$s=IO::Socket::INET->new(PeerAddr=>$me->Host(),PeerPort=>$me->Port(),Proto=>"tcp",Type=>SOCK_STREAM,LocalAddr=>$me->LocalAddr(),Timeout=>$me->{TIMEOUT})or$me->Message("could not connect socket [$me->{HOST}, $me->{PORT}]: $!")and return 0;
$me->{SOCKET}=$s;}};
$s->autoflush(1);
defined(my$msg=$me->_sockread())or$me->Message("Could not read")and return 0;
chomp$msg;
$me->{BANNER}=$msg;
$me->Message($msg);
$msg=~/^\+OK/i||return 0;
my$atom=qr([-_\w!#$%&'*+/=?^`{|}~]+);
$me->{MESG_ID}=$1 if($msg=~/(<$atom(?:\.$atom)*\@$atom(?:\.$atom)*>)/o);
$me->Message($msg);
$me->State('AUTHORIZATION');
defined($me->User())and defined($me->Pass())and$me->Login();}sub connect{Connect(@_);}sub Login{my$me=shift;
return 1 if$me->State eq 'TRANSACTION';
my$auth_mode=$me->{NEXT_AUTH_MODE}||$me->{AUTH_MODE};
if($auth_mode eq 'BEST'){my$retval;
if($me->{MESG_ID}){$retval=$me->Login_APOP();
return($retval)if($me->State eq 'TRANSACTION');
if($me->State eq 'DEAD'){$me->{NEXT_AUTH_MODE}='PASS';return$me->Connect($me->Host(),$me->Port());}}my$has_cram_md5=0;
foreach my $capa($me->Capa()){$capa=~/^SASL.*?\sCRAM-MD5\b/ and$has_cram_md5=1 and last;}if($has_cram_md5){$retval=$me->Login_CRAM_MD5();
return($retval)if($me->State()eq 'TRANSACTION');
if($me->State eq 'DEAD'){$me->{NEXT_AUTH_MODE}='PASS';return$me->Connect($me->Host(),$me->Port());}}if($me->State eq 'DEAD'){$me->{NEXT_AUTH_MODE}='PASS';return$me->Connect($me->Host(),$me->Port());}}elsif($auth_mode eq 'APOP'){return(0)if(!$me->{MESG_ID});
return($me->Login_APOP());}elsif($auth_mode eq 'CRAM-MD5'){return($me->Login_CRAM_MD5());}elsif($auth_mode ne 'PASS'){$me->Message("Programming error. AUTH_MODE ($auth_mode) not BEST | APOP | CRAM-MD5 | PASS.");
return(0);}return($me->Login_Pass());}sub login{Login(@_);}sub Login_APOP{my$me=shift;
eval{require Digest::MD5;};
$@and$me->Message("APOP failed: $@")and return 0;
my$hash=Digest::MD5::md5_hex($me->{MESG_ID}.$me->Pass());
$me->_checkstate('AUTHORIZATION','APOP')or return 0;
$me->_sockprint("APOP ",$me->User,' ',$hash,$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for APOP");
$me->State('AUTHORIZATION');
return 0;}chomp$line;
$me->Message($line);
$me->NOOP()||do{$me->State('DEAD');
undef$me->{SOCKET};
$me->Message("APOP failed: server has closed the socket");
return 0;};
$line=~/^\+OK/ or$me->Message("APOP failed: $line")and return 0;
$me->State('TRANSACTION');
$me->POPStat()or return 0;}sub Login_CRAM_MD5{my$me=shift;
eval{require Digest::HMAC_MD5;
require MIME::Base64;};
$@and$me->Message("AUTH CRAM-MD5 failed: $@")and return 0;
$me->_checkstate('AUTHORIZATION','AUTH')or return 0;
$me->_sockprint('AUTH CRAM-MD5',$me->EOL());
my$line=$me->_sockread();
chomp$line;
$me->Message($line);
if($line=~/^\+ (.+)$/){my$hmac=Digest::HMAC_MD5::hmac_md5_hex(MIME::Base64::decode($1),$me->Pass());
(my$response=MIME::Base64::encode($me->User()." $hmac"))=~s/[\r\n]//g;
$me->_sockprint($response,$me->EOL());
$line=$me->_sockread();
chomp$line;
$me->Message($line);
$line=~/^\+OK/ or$me->Message("AUTH CRAM-MD5 failed: $line")and return 0;}else{$me->Message("AUTH CRAM-MD5 failed: $line")and return 0;}$me->State('TRANSACTION');
$me->POPStat()or return 0;}sub Login_Pass{my$me=shift;
$me->_checkstate('AUTHORIZATION','USER')or return 0;
$me->_sockprint("USER ",$me->User(),$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for USER");
$me->State('AUTHORIZATION');
return 0;}chomp$line;
$me->Message($line);
$line=~/^\+/ or$me->Message("USER failed: $line")and$me->State('AUTHORIZATION')and return 0;
$me->_sockprint("PASS ",$me->Pass(),$me->EOL);
$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for PASS");
$me->State('AUTHORIZATION');
return 0;}chomp$line;
$me->Message($line);
$line=~/^\+OK/ or$me->Message("PASS failed: $line")and$me->State('AUTHORIZATION')and return 0;
$me->State('TRANSACTION');
($me->POPStat()>=0)or return 0;}sub Head{my$me=shift;
my$num=shift;
my$lines=shift;
$lines||=0;
$lines=~/\d+/||($lines=0);
my$header='';
$me->_checkstate('TRANSACTION','TOP')or return;
$me->_sockprint("TOP $num $lines",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for TOP");
return;}chomp$line;
$line=~/^\+OK/ or$me->Message("Bad return from TOP: $line")and return;
$line=~/^\+OK (\d+) / and my$buflen=$1;
while(1){$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for TOP");
return;}last if$line=~/^\.\s*$/;
$line=~s/^\.\././;
$header.=$line;}return wantarray?split(/\r?\n/,$header):$header;}sub HeadAndBody{my$me=shift;
my$num=shift;
my$mandb='';
$me->_checkstate('TRANSACTION','RETR')or return;
$me->_sockprint("RETR $num",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return;}chomp$line;
$line=~/^\+OK/ or$me->Message("Bad return from RETR: $line")and return;
$line=~/^\+OK (\d+) / and my$buflen=$1;
while(1){$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return;}last if$line=~/^\.\s*$/;
$line=~s/^\.\././;
$mandb.=$line;}return wantarray?split(/\r?\n/,$mandb):$mandb;}sub message_string{HeadAndBody(@_);}sub HeadAndBodyToFile{local($,,$\);
my$me=shift;
my$fh=shift;
my$num=shift;
my$body='';
$me->_checkstate('TRANSACTION','RETR')or return;
$me->_sockprint("RETR $num",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return 0;}chomp$line;
$line=~/^\+OK/ or$me->Message("Bad return from RETR: $line")and return 0;
$line=~/^\+OK (\d+) / and my$buflen=$1;
while(1){$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return 0;}last if$line=~/^\.\s*$/;
$line=~s/^\.\././;
print$fh $line;}return 1;}sub Body{my$me=shift;
my$num=shift;
my$body='';
$me->_checkstate('TRANSACTION','RETR')or return;
$me->_sockprint("RETR $num",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return;}chomp$line;
$line=~/^\+OK/ or$me->Message("Bad return from RETR: $line")and return;
$line=~/^\+OK (\d+) / and my$buflen=$1;
do{$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return;}$line=~s/[\r\n]//g;}until$line=~/^(\s*|\.)$/;
$line=~/^\.\s*$/&&return;
while(1){$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return;}last if$line=~/^\.\s*$/;
$line=~s/^\.\././;
$body.=$line;}return wantarray?split(/\r?\n/,$body):$body;}sub BodyToFile{local($,,$\);
my$me=shift;
my$fh=shift;
my$num=shift;
my$body='';
$me->_checkstate('TRANSACTION','RETR')or return;
$me->_sockprint("RETR $num",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return;}chomp$line;
$line=~/^\+OK/ or$me->Message("Bad return from RETR: $line")and return;
$line=~/^\+OK (\d+) / and my$buflen=$1;
do{$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return;}$line=~s/[\r\n]//g;}until$line=~/^(\s*|\.)$/;
$line=~/^\.\s*$/&&return;
while(1){$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RETR");
return;}chomp$line;
last if$line=~/^\.\s*$/;
$line=~s/^\.\././;
print$fh $line,"\n";}}sub POPStat{my$me=shift;
$me->_checkstate('TRANSACTION','STAT')or return-1;
$me->_sockprint("STAT",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for STAT");
return-1;}$line=~/^\+OK/ or$me->Message("STAT failed: $line")and return-1;
$line=~/^\+OK (\d+) (\d+)/ and$me->Count($1),$me->Size($2);
return$me->Count();}sub List{my$me=shift;
my$num=shift||'';
my$CMD=shift||'LIST';
$CMD=~tr/a-z/A-Z/;
$me->Alive()or return;
my@retarray=();
my$ret='';
$me->_checkstate('TRANSACTION',$CMD)or return;
$me->_sockprint($CMD,$num?" $num":'',$me->EOL());
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for LIST");
return;}$line=~/^\+OK/ or$me->Message("$line")and return;
if($num){$line=~s/^\+OK\s*//;
return$line;}while(defined($line=$me->_sockread())){$line=~/^\.\s*$/ and last;
$ret.=$line;
chomp$line;
push(@retarray,$line);}if($ret){return wantarray?@retarray:$ret;}}sub ListArray{my$me=shift;
my$num=shift||'';
my$CMD=shift||'LIST';
$CMD=~tr/a-z/A-Z/;
$me->Alive()or return;
my@retarray=();
my$ret='';
$me->_checkstate('TRANSACTION',$CMD)or return;
$me->_sockprint($CMD,$num?" $num":'',$me->EOL());
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for LIST");
return;}$line=~/^\+OK/ or$me->Message("$line")and return;
if($num){$line=~s/^\+OK\s*//;
return$line;}while(defined($line=$me->_sockread())){$line=~/^\.\s*$/ and last;
$ret.=$line;
chomp$line;
my($num,$uidl)=split('\s+',$line);
$retarray[$num]=$uidl;}if($ret){return wantarray?@retarray:$ret;}}sub Retrieve{return HeadAndBody(@_);}sub RetrieveToFile{return HeadAndBodyToFile(@_);}sub Last{my$me=shift;
$me->_checkstate('TRANSACTION','LAST')or return;
$me->_sockprint("LAST",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for LAST");
return 0;}$line=~/\+OK (\d+)\D*$/ and return$1;}sub Reset{my$me=shift;
$me->_checkstate('TRANSACTION','RSET')or return;
$me->_sockprint("RSET",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for RSET");
return 0;}$line=~/^\+OK/ and return 1;
return 0;}sub Delete{my$me=shift;
my$num=shift||return;
$me->_checkstate('TRANSACTION','DELE')or return;
$me->_sockprint("DELE $num",$me->EOL);
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for DELE");
return 0;}$me->Message($line);
$line=~/^\+OK/&&return 1;
return 0;}sub delete_message{Delete(@_);}sub Uidl{my$me=shift;
my$num=shift||'';
$me->Alive()or return;
my@retarray=();
my$ret='';
$me->_checkstate('TRANSACTION','UIDL')or return;
$me->_sockprint('UIDL',$num?" $num":'',$me->EOL());
my$line=$me->_sockread();
unless(defined$line){$me->Message("Socket read failed for UIDL");
return;}$line=~/^\+OK/ or$me->Message($line)and return;
if($num){$line=~s/^\+OK\s*//;
return$line;}while(defined($line=$me->_sockread())){$line=~/^\.\s*$/ and last;
$ret.=$line;
chomp$line;
my($num,$uidl)=split('\s+',$line);
$retarray[$num]=$uidl;}if($ret){return wantarray?@retarray:$ret;}}sub Capa{my$me=shift;
$me->Alive()or return;
my@retarray=();
my$ret='';
$me->_sockprint('CAPA',$me->EOL());
my$line=$me->_sockread();
$line=~/^\+OK/ or$me->Message($line)and return;
while(defined($line=$me->_sockread())){$line=~/^\.\s*$/ and last;
$ret.=$line;
chomp$line;
push(@retarray,$line);}if($ret){return wantarray?@retarray:$ret;}}sub Xtnd{my$me=shift;
my$xtndarg=shift||'';
if($xtndarg eq ''){$me->Message("XTND requires a string argument");
return;}my$s=$me->Socket();
$me->_checkstate('TRANSACTION','XTND')or return;
$me->Alive()or return;
$me->_sockprint("XTND $xtndarg",$me->EOL);
my$line=$me->_sockread();
$line=~/^\+OK/ or$me->Message($line)and return;
$line=~s/^\+OK\s*//;
return$line;}sub NOOP{my$me=shift;
my$s=$me->Socket();
$me->Alive()or return 0;
$me->_sockprint("NOOP",$me->EOL);
my$line=$me->_sockread();
$line=~/^\+OK/ or return 0;
return 1;}sub Peek{}sub Uid{}sub folders{return('INBOX');}sub Folder{return('INBOX');}sub select{}sub unseen{my$me=shift;
my$count=$me->Count;
return()if!$count;
return(1..$count);}sub _checkstate{my($me,$state,$cmd)=@_;
my$currstate=$me->State();
if($currstate ne$state){$me->Message("POP3 command $cmd may be given only in the '$state' state "."(current state is '$currstate').");
return 0;}else{return 1;}}sub _sockprint{local($,,$\);
my$me=shift;
my$s=$me->Socket();
$me->Debug and Carp::carp"POP3 -> ",@_;
my$outline="@_";
chomp$outline;
push(@{$me->{tranlog}},$outline);
print$s @_;}sub _sockread{my$me=shift;
my$line=$me->Socket()->getline();
unless(defined$line){return;}$me->{STRIPCR}&&($line=~s/^[\r]+//);
$me->Debug and Carp::carp"POP3 <- ",$line;
$line=~/^[\\+\\-](OK|ERR)/i&&do{my$l=$line;
chomp$l;
push(@{$me->{tranlog}},$l);};
return$line;}1;
__END__



################################################################################
# POD Documentation (perldoc Mail::POP3Client or pod2html this_file)
################################################################################

